#define	NSNAME	8
#define	NSYM	50
#define	NREG	32
#define NOPROF	(1<<0)
#define DUPOK	(1<<1)

enum
{
	REGZERO		= 0,	/* always zero */
	REGRET		= 1,	/* fn return value */
	REGARG		= 1,	/* fn arg value */
	REGEXT		= 24,	/* extern reg from here down */
	REGBPTMP	= 25,	/* breakpoint temporary */
	REGSB		= 26,	/* static base */
	REGSP		= 27,	/* stack pointer */
	REGTMP		= 28,	/* assembler temporary */
	REGEA		= 29,	/* exception return address */
	REGBA		= 30,	/* breakpoint return address */
	REGLINK		= 31,	/* call return address */
};

enum	as
{
	AXXX = 0,

	/* processor instructions */
	AADD,
	AAND,
	ABEQ,
	ABGE,
	ABGEU,
	ABLT,
	ABLTU,
	ABNE,
	ABR,
	ABREAK,
	ABRET,
	ACALL,
	ACMPEQ,
	ACMPGE,
	ACMPGEU,
	ACMPLT,
	ACMPLTU,
	ACMPNE,
	ACUSTOM,
	ADIV,
	ADIVU,
	AERET,
	AFLUSHD,
	AFLUSHDA,
	AFLUSHI,
	AFLUSHP,
	AINITD,
	AINITDA,
	AINITI,
	AJMP,
	AMUL,
	AMULXSS,
	AMULXSU,
	AMULXUU,
	ANEXTPC,
	ANOR,
	AOR,
	ARDPRS,
	ARET,
	AROL,
	AROR,
	ASLL,
	ASRA,
	ASRL,
	ASUB,
	ASYNC,
	ATRAP,
	AXOR,

	/* pseudo-ops */
	ABGT,
	ABGTU,
	ABLE,
	ABLEU,
	ACMPGT,
	ACMPGTU,
	ACMPLE,
	ACMPLEU,
	ANOP,

	/* load-store pseudo-ops */
	AMOVB,
	AMOVBIO,
	AMOVBU,
	AMOVBUIO,
	AMOVH,
	AMOVHIO,
	AMOVHU,
	AMOVHUIO,
	AMOVW,
	AMOVWIO,

	/* C compiler pseudo-ops */
	ADATA,
	AGLOBL,
	AGOK,
	AHISTORY,
	ANAME,
	ATEXT,
	AWORD,
	AEND,
	ADYNT,
	AINIT,
	ASIGNAME,

	ALAST,
};

/* type/name */
enum
{
	D_GOK	= 0,
	D_NONE,

/* name */
	D_EXTERN,
	D_STATIC,
	D_AUTO,
	D_PARAM,

/* type */
	D_BRANCH,
	D_OREG,
	D_CONST,
	D_FCONST,
	D_SCONST,
	D_REG,
	D_CTLREG,
	D_PRSREG,
	D_FILE,
	D_FILE1,
};

/*
 * this is the ranlib header
 */
#define	SYMDEF	"__.SYMDEF"

/*
 * this is the simulated IEEE floating point
 */
typedef	struct	ieee	Ieee;
struct	ieee
{
	long	l;	/* contains ls-man	0xffffffff */
	long	h;	/* contains sign	0x80000000
				    exp		0x7ff00000
				    ms-man	0x000fffff */
};
