#include	"l.h"

long	OFFSET;

#define	LPUT(c)\
	{\
		cbp[0] = (c);\
		cbp[1] = (c)>>8;\
		cbp[2] = (c)>>16;\
		cbp[3] = (c)>>24;\
		cbp += 4;\
		cbc -= 4;\
		if(cbc <= 0)\
			cflush();\
	}

#define	LBEPUT(c)\
	{\
		cbp[0] = (c)>>24;\
		cbp[1] = (c)>>16;\
		cbp[2] = (c)>>8;\
		cbp[3] = (c);\
		cbp += 4;\
		cbc -= 4;\
		if(cbc <= 0)\
			cflush();\
	}

#define	HPUT(c)\
	{\
		cbp[0] = (c);\
		cbp[1] = (c)>>8;\
		cbp += 2;\
		cbc -= 2;\
		if(cbc <= 0)\
			cflush();\
	}

#define	CPUT(c)\
	{\
		cbp[0] = (c);\
		cbp++;\
		cbc--;\
		if(cbc <= 0)\
			cflush();\
	}

void
objput(long l)	/* emit long in byte order appropriate to object machine */
{
	LPUT(l);
}

void
objhput(short s)
{
	HPUT(s);
}

void
lput(long l)		/* emit long in big-endian byte order */
{
	LBEPUT(l);
}

long
entryvalue(void)
{
	char *a;
	Sym *s;

	a = INITENTRY;
	if(*a >= '0' && *a <= '9')
		return atolwhex(a);
	s = lookup(a, 0);
	if(s->type == 0)
		return INITTEXT;
	if(s->type != STEXT && s->type != SLEAF)
		diag("entry not text: %s", s->name);
	return s->value;
}

void
asmb(void)
{
	Prog *p;
	long t, etext;
	Optab *o;

	if(debug['v'])
		Bprint(&bso, "%5.2f asm\n", cputime());
	Bflush(&bso);
	OFFSET = HEADR;
	seek(cout, OFFSET, 0);
	pc = INITTEXT;
	for(p = firstp; p != P; p = p->link) {
		if(p->as == ATEXT) {
			curtext = p;
			autosize = p->to.offset + 4;
		}
		if(p->pc != pc) {
			diag("phase error %lux sb %lux",
				p->pc, pc);
			if(!debug['a'])
				prasm(curp);
			pc = p->pc;
		}
		curp = p;
		o = oplook(p);	/* could probably avoid this call */
		if(asmout(p, o, 0)) {
			p = p->link;
			pc += 4;
		}
		pc += o->size;
	}
	if(debug['a'])
		Bprint(&bso, "\n");
	Bflush(&bso);
	cflush();

	etext = INITTEXT + textsize;
	for(t = pc; t < etext; t += sizeof(buf)-100) {
		if(etext-t > sizeof(buf)-100)
			datblk(t, sizeof(buf)-100, 1);
		else
			datblk(t, etext-t, 1);
	}

	Bflush(&bso);
	cflush();

	curtext = P;
	switch(HEADTYPE) {
	case 0:
	case 4:
		OFFSET = rnd(HEADR+textsize, 4096);
		seek(cout, OFFSET, 0);
		break;
	case 1:
	case 2:
	case 3:
	case 5:
	case 6:
		OFFSET = HEADR+textsize;
		seek(cout, OFFSET, 0);
		break;
	}
	for(t = 0; t < datsize; t += sizeof(buf)-100) {
		if(datsize-t > sizeof(buf)-100)
			datblk(t, sizeof(buf)-100, 0);
		else
			datblk(t, datsize-t, 0);
	}

	symsize = 0;
	lcsize = 0;
	if(!debug['s']) {
		if(debug['v'])
			Bprint(&bso, "%5.2f sym\n", cputime());
		Bflush(&bso);
		switch(HEADTYPE) {
		case 0:
		case 4:
			OFFSET = rnd(HEADR+textsize, 4096)+datsize;
			seek(cout, OFFSET, 0);
			break;
		case 3:
		case 2:
		case 1:
		case 5:
		case 6:
			OFFSET = HEADR+textsize+datsize;
			seek(cout, OFFSET, 0);
			break;
		}
		if(!debug['s'])
			asmsym();
		if(debug['v'])
			Bprint(&bso, "%5.2f pc\n", cputime());
		Bflush(&bso);
		if(!debug['s'])
			asmlc();
		cflush();
	}

	if(debug['v'])
		Bprint(&bso, "%5.2f header\n", cputime());
	Bflush(&bso);
	OFFSET = 0;
	seek(cout, OFFSET, 0);
	switch(HEADTYPE) {
	case 1:
		break;
	case 2:
		t = 28;
		lput(((((4*t)+0)*t)+7));	/* magic */
		lput(textsize);			/* sizes */
		lput(datsize);
		lput(bsssize);
		lput(symsize);			/* nsyms */
		lput(entryvalue());		/* va of entry */
		lput(0L);
		lput(lcsize);
		break;
	case 5:
		/* first part of ELF is byte-wide parts, thus no byte-order issues */
		strnput("\177ELF", 4);		/* e_ident */
		CPUT(1);			/* class = 32 bit */
		CPUT(1);			/* data: 1 = LSB, 2 = MSB */
		CPUT(1);			/* version = 1 */
		strnput("", 9);			/* reserved for expansion */
		/* entire remainder of ELF file is in target byte order */

		/* file header part of ELF header */
		objhput(2);			/* type = EXEC */
		objhput(113);		/* machine = NIOS */
		objput(1L);			/* version = CURRENT */
		objput(entryvalue());		/* entry vaddr */
		objput(52L);			/* offset to first phdr */
		objput(0L);			/* offset to first shdr */
		objput(0L);			/* flags (no MIPS flags defined) */
		objhput(52);			/* Ehdr size */
		objhput(32);			/* Phdr size */
		objhput(3);			/* # of Phdrs */
		objhput(0);			/* Shdr size */
		objhput(0);			/* # of Shdrs */
		objhput(0);			/* Shdr string size */

		/* "Program headers" - one per chunk of file to load */

		/*
		 * Don't include ELF headers in text
		 */
		objput(1L);			/* text: type = PT_LOAD */
		objput(HEADR);			/* file offset */
		objput(INITTEXT);		/* vaddr */
		objput(INITTEXT);		/* paddr */
		objput(textsize);		/* file size */
		objput(textsize);		/* memory size */
		objput(0x05L);			/* protections = RX */
		objput(0x1000L);		/* page-align text off's & vaddrs */

		objput(1L);			/* data: type = PT_LOAD */
		objput(HEADR+textsize);		/* file offset */
		objput(INITDAT);		/* vaddr */
		objput(INITDAT);		/* paddr */
		objput(datsize);		/* file size */
		objput(datsize+bsssize);	/* memory size */
		objput(0x06L);			/* protections = RW */
		if(INITDAT % 4096 == 0 && (HEADR + textsize) % 4096 == 0)
			objput(0x1000L);	/* page-align data off's & vaddrs */
		else
			objput(0L);		/* do not claim alignment */

		objput(0L);			/* P9 symbols: type = PT_NULL */
		objput(HEADR+textsize+datsize);	/* file offset */
		objput(0L);
		objput(0L);
		objput(symsize);		/* symbol table size */
		objput(lcsize);			/* line number size */
		objput(0x04L);			/* protections = R */
		objput(0L);			/* do not claim alignment */
		break;
	}
	cflush();
}

void
strnput(char *s, int n)
{
	for(; *s; s++){
		CPUT(*s);
		n--;
	}
	for(; n > 0; n--)
		CPUT(0);
}

void
cflush(void)
{
	int n;

	n = sizeof(buf.cbuf) - cbc;
	if(n)
		write(cout, buf.cbuf, n);
	cbp = buf.cbuf;
	cbc = sizeof(buf.cbuf);
}

void
nopstat(char *f, Count *c)
{
	if(c->outof)
	Bprint(&bso, "%s delay %ld/%ld (%.2f)\n", f,
		c->outof - c->count, c->outof,
		(double)(c->outof - c->count)/c->outof);
}

void
asmsym(void)
{
	Prog *p;
	Auto *a;
	Sym *s;
	int h;

	s = lookup("etext", 0);
	if(s->type == STEXT)
		putsymb(s->name, 'T', s->value, s->version);

	for(h=0; h<NHASH; h++)
		for(s=hash[h]; s!=S; s=s->link)
			switch(s->type) {
			case SCONST:
				putsymb(s->name, 'D', s->value, s->version);
				continue;

			case SSTRING:
				putsymb(s->name, 'T', s->value, s->version);
				continue;

			case SDATA:
				putsymb(s->name, 'D', s->value+INITDAT, s->version);
				continue;

			case SBSS:
				putsymb(s->name, 'B', s->value+INITDAT, s->version);
				continue;

			case SFILE:
				putsymb(s->name, 'f', s->value, s->version);
				continue;
			}

	for(p=textp; p!=P; p=p->cond) {
		s = p->from.sym;
		if(s->type != STEXT && s->type != SLEAF)
			continue;

		/* filenames first */
		for(a=p->to.autom; a; a=a->link)
			if(a->type == D_FILE)
				putsymb(a->asym->name, 'z', a->aoffset, 0);
			else
			if(a->type == D_FILE1)
				putsymb(a->asym->name, 'Z', a->aoffset, 0);

		if(s->type == STEXT)
			putsymb(s->name, 'T', s->value, s->version);
		else
			putsymb(s->name, 'L', s->value, s->version);

		/* frame, auto and param after */
		putsymb(".frame", 'm', p->to.offset+4, 0);
		for(a=p->to.autom; a; a=a->link)
			if(a->type == D_AUTO)
				putsymb(a->asym->name, 'a', -a->aoffset, 0);
			else
			if(a->type == D_PARAM)
				putsymb(a->asym->name, 'p', a->aoffset, 0);
	}
	if(debug['v'] || debug['n'])
		Bprint(&bso, "symsize = %lud\n", symsize);
	Bflush(&bso);
}

void
putsymb(char *s, int t, long v, int ver)
{
	int i, f;

	if(t == 'f')
		s++;
	LBEPUT(v);
	if(ver)
		t += 'a' - 'A';
	CPUT(t+0x80);			/* 0x80 is variable length */

	if(t == 'Z' || t == 'z') {
		CPUT(s[0]);
		for(i=1; s[i] != 0 || s[i+1] != 0; i += 2) {
			CPUT(s[i]);
			CPUT(s[i+1]);
		}
		CPUT(0);
		CPUT(0);
		i++;
	}
	else {
		for(i=0; s[i]; i++)
			CPUT(s[i]);
		CPUT(0);
	}
	symsize += 4 + 1 + i + 1;

	if(debug['n']) {
		if(t == 'z' || t == 'Z') {
			Bprint(&bso, "%c %.8lux ", t, v);
			for(i=1; s[i] != 0 || s[i+1] != 0; i+=2) {
				f = ((s[i]&0xff) << 8) | (s[i+1]&0xff);
				Bprint(&bso, "/%x", f);
			}
			Bprint(&bso, "\n");
			return;
		}
		if(ver)
			Bprint(&bso, "%c %.8lux %s<%d>\n", t, v, s, ver);
		else
			Bprint(&bso, "%c %.8lux %s\n", t, v, s);
	}
}

#define	MINLC	4
void
asmlc(void)
{
	long oldpc, oldlc;
	Prog *p;
	long v, s;

	oldpc = INITTEXT;
	oldlc = 0;
	for(p = firstp; p != P; p = p->link) {
		if(p->line == oldlc || p->as == ATEXT || p->as == ANOP) {
			if(p->as == ATEXT)
				curtext = p;
			if(debug['L'])
				Bprint(&bso, "%6lux %P\n",
					p->pc, p);
			continue;
		}
		if(debug['L'])
			Bprint(&bso, "\t\t%6ld", lcsize);
		v = (p->pc - oldpc) / MINLC;
		while(v) {
			s = 127;
			if(v < 127)
				s = v;
			CPUT(s+128);	/* 129-255 +pc */
			if(debug['L'])
				Bprint(&bso, " pc+%ld*%d(%ld)", s, MINLC, s+128);
			v -= s;
			lcsize++;
		}
		s = p->line - oldlc;
		oldlc = p->line;
		oldpc = p->pc + MINLC;
		if(s > 64 || s < -64) {
			CPUT(0);	/* 0 vv +lc */
			CPUT(s>>24);
			CPUT(s>>16);
			CPUT(s>>8);
			CPUT(s);
			if(debug['L']) {
				if(s > 0)
					Bprint(&bso, " lc+%ld(%d,%ld)\n",
						s, 0, s);
				else
					Bprint(&bso, " lc%ld(%d,%ld)\n",
						s, 0, s);
				Bprint(&bso, "%6lux %P\n",
					p->pc, p);
			}
			lcsize += 5;
			continue;
		}
		if(s > 0) {
			CPUT(0+s);	/* 1-64 +lc */
			if(debug['L']) {
				Bprint(&bso, " lc+%ld(%ld)\n", s, 0+s);
				Bprint(&bso, "%6lux %P\n",
					p->pc, p);
			}
		} else {
			CPUT(64-s);	/* 65-128 -lc */
			if(debug['L']) {
				Bprint(&bso, " lc%ld(%ld)\n", s, 64-s);
				Bprint(&bso, "%6lux %P\n",
					p->pc, p);
			}
		}
		lcsize++;
	}
	while(lcsize & 1) {
		s = 129;
		CPUT(s);
		lcsize++;
	}
	if(debug['v'] || debug['L'])
		Bprint(&bso, "lcsize = %ld\n", lcsize);
	Bflush(&bso);
}

void
datblk(long s, long n, int str)
{
	Prog *p;
	char *cast;
	long l, fl, j, d;
	int i, c;

	memset(buf.dbuf, 0, n+100);
	for(p = datap; p != P; p = p->link) {
		curp = p;
		if(str != (p->from.sym->type == SSTRING))
			continue;
		l = p->from.sym->value + p->from.offset - s;
		c = p->reg;
		i = 0;
		if(l < 0) {
			if(l+c <= 0)
				continue;
			while(l < 0) {
				l++;
				i++;
			}
		}
		if(l >= n)
			continue;
		if(p->as != AINIT && p->as != ADYNT) {
			for(j=l+(c-i)-1; j>=l; j--)
				if(buf.dbuf[j]) {
					print("%P\n", p);
					diag("multiple initialization");
					break;
				}
		}
		switch(p->to.type) {
		default:
			diag("unknown mode in initialization\n%P", p);
			break;

		case D_FCONST:
			switch(c) {
			default:
			case 4:
				fl = ieeedtof(p->to.ieee);
				cast = (char*)&fl;
				for(; i<c; i++) {
					buf.dbuf[l] = cast[fnuxi8[i+4]];
					l++;
				}
				break;
			case 8:
				cast = (char*)p->to.ieee;
				for(; i<c; i++) {
					buf.dbuf[l] = cast[fnuxi8[i]];
					l++;
				}
				break;
			}
			break;

		case D_SCONST:
			for(; i<c; i++) {
				buf.dbuf[l] = p->to.sval[i];
				l++;
			}
			break;

		case D_CONST:
			d = p->to.offset;
			if(p->to.sym) {
				switch(p->to.sym->type) {
				case STEXT:
				case SLEAF:
				case SSTRING:
					d += p->to.sym->value;
					break;
				case SDATA:
				case SBSS:
					d += p->to.sym->value + INITDAT;
					break;
				}
			}
			cast = (char*)&d;
			switch(c) {
			default:
				diag("bad nuxi %d %d\n%P", c, i, curp);
				break;
			case 1:
				for(; i<c; i++) {
					buf.dbuf[l] = cast[inuxi1[i]];
					l++;
				}
				break;
			case 2:
				for(; i<c; i++) {
					buf.dbuf[l] = cast[inuxi2[i]];
					l++;
				}
				break;
			case 4:
				for(; i<c; i++) {
					buf.dbuf[l] = cast[inuxi4[i]];
					l++;
				}
				break;
			}
			break;
		}
	}
	write(cout, buf.dbuf, n);
}

#define R(n) ((n)&31L)
#define	OP_ORI(op,ra,rb,rc,i)\
	(R(ra)<<27 | R(rb)<<22 | R(rc)<<17 | ((op)&0x3F)<<11 | ((i)&0x1F)<<6 | 0x3A)
#define OP_RI(ra,rb,rc,i)\
	OP_ORI(o->op,ra,rb,rc,i)
#define OP_R(ra,rb,rc)\
	OP_RI(ra,rb,rc,0)
#define	OP_OI(op,ra,rb,i)\
	(R(ra)<<27 | R(rb)<<22 | ((i)&0xFFFF)<<6 | (op)&0x3F)
#define OP_I(ra,rb,i)\
	OP_OI(o->op,ra,rb,i)
#define	OP_J(i)\
	(((i)&0x3ffffffL)<<6 | o->op)
#define	OP_C(op,ra,rb,rc,rr)\
	(R(ra)<<27 | R(rb)<<22 | R(rc)<<17 | (rr)<<14 | ((op)&0xFF)<<6 | 0x32)

enum {
	Oori	= 0x14,
	Oorhi	= 0x34,
};

int
custom(int n, int v)
{
	int ra, rb, rc, rr;

	ra = (v>>16)&0xFF;
	rb = (v>>8)&0xFF;
	rc = v&0xFF;
	rr = 0;
	if(ra < NREG)
		rr |= 4;
	if(rb < NREG)
		rr |= 2;
	if(rc < NREG)
		rr |= 1;
	return OP_C(n, ra, rb, rc, rr);
}

int
asmout(Prog *p, Optab *o, int aflag)
{
	long o1, o2, o3, v;
	Prog *ct;
	int r;

	o1 = 0;
	o2 = 0;
	o3 = 0;
	r = p->reg;
	if(r == NREG)
		r = p->as == AMOVW? 0 : p->to.reg;
	switch(o->type) {
	default:
		diag("unknown type %d", o->type);
		if(!debug['a'])
			prasm(p);
		break;

	case 0:		/* jmp L */
		if(p->cond == P)
			v = p->pc >> 2;
		else
			v = p->cond->pc >> 2;
		o1 = OP_J(v);
		break;

	case 1:		/* movb Is(A),B */
		v = regoff(&p->from);
		r = classreg(&p->from);
		o1 = OP_I(r, p->to.reg, v);
		break;

	case 2:		/* add $Is,[A,]B */
		o1 = OP_I(r, p->to.reg, p->from.offset);
		break;

	case 3:		/* movb A,Is(B) */
		v = regoff(&p->to);
		r = classreg(&p->to);
		o1 = OP_I(r, p->from.reg, v);
		break;

	case 4:		/* and	$Ih,[A,]B */
		o1 = OP_I(r, p->to.reg, p->from.offset>>16);
		break;

	case 5:		/* or	$I,[A,]B */
		o1 = OP_OI(o->op, r, p->to.reg, p->from.offset>>16);
		o2 = OP_OI(o->param, r, p->to.reg, p->from.offset);
		break;

	case 6:		/* beq B,A,L */
		if(r == NREG)
			r = REGZERO;
		if(p->cond == P)
			v = -4;
		else
			v = (p->cond->pc - (pc+4));
		o1 = OP_I(r, p->from.reg, v);
		break;

	case 7:		/* flushd Is(A) */
		v = regoff(&p->to);
		r = classreg(&p->to);
		o1 = OP_I(r, 0, v);
		break;

	case 8:		/* rdprs	$Is,PR(A),B */
		o1 = OP_I(p->reg, p->to.reg, p->from.offset);
		break;

	case 9:		/* custom */
		o1 = custom(p->from.offset, p->to.offset);
		print("custom: %d %c(%d) %c(%d) %c(%d)\n",
			(o1>>6)&0xFF, o1&(1<<16)? 'R' : 'C', R(o1>>27),
			 o1&(1<<15)? 'R' : 'C', R(o1>>22),
			 o1&(1<<14)? 'R' : 'C', R(o1>>17));
		break;

	case 10:	/* bret */
		o1 = OP_R(o->param>>8, o->param, 0);
		break;

	case 11:	/* rol	$I,[A,]C */
		v = p->from.offset;
		o1 = OP_RI(r, 0, p->to.reg, v);
		break;

	case 12:	/* add	B,[A,]C */
		o1 = OP_R(r, p->from.reg, p->to.reg);
		break;

	case 13:	/* cmpeq B,A,C */
		o1 = OP_R(r, p->from.reg, p->to.reg);
		break;

	case 14:	/* call (A) */
		o1 = OP_RI(p->to.reg, 0, 0, o->param);
		break;

	case 15:	/* movw	C,PRS(A) */
		o1 = OP_R(p->to.reg, 0, p->from.reg);
		break;

	case 16:	/* nextpc (C) */
		o1 = OP_R(0, 0, p->to.reg);
		break;

	case 17:	/* movw	CTL(N),C */
		o1 = OP_RI(0, 0, p->to.reg, p->from.reg);
		break;

	case 18:	/* break N */
		o1 = OP_RI(0, 0, o->param, p->to.offset);
		break;

	case 19:	/* movw	A,CTL(n) */
		o1 = OP_RI(p->from.reg, 0, 0, p->to.reg);
		break;

	case 20:	/* add $I,[A,],B */
		o1 = OP_OI(Oori, REGZERO, REGTMP, p->from.offset);
		o2 = OP_OI(Oorhi, REGZERO, REGTMP, p->from.offset>>16);
		o3 = OP_R(REGTMP, r, p->to.reg);
		break;

	case 21:	/* movw	$Is,B */
		o1 = OP_I(REGZERO, p->to.reg, p->from.offset);
		break;

	case 22:	/* movw $Ih, B */
		o1 = OP_I(REGZERO, p->to.reg, p->from.offset>>16);
		break;

	case 23:	/* movw	$I, B */
		v = regoff(&p->from);
		o1 = OP_OI(Oori, REGZERO, p->to.reg, v);
		o2 = OP_OI(Oorhi, p->to.reg, p->to.reg, v>>16);
		break;

	case 24:	/* movb A, B */
		v = p->as == AMOVB ? 24 : 16;
		o1 = OP_ORI(o->param, p->from.reg, 0, p->to.reg, v);
		o2 = OP_ORI(o->op, p->to.reg, 0, p->to.reg, v);
		break;

	case 25:	/* movbu A, B */
		v = p->as == AMOVBU ? 0xFF : 0xFFFF;
		o1 = OP_I(p->from.reg, p->to.reg, v);
		break;

	case 26:
	case 27:		/* pseudo ops */
		if(aflag) {
			if(p->link) {
				if(p->as == ATEXT) {
					ct = curtext;
					o2 = autosize;
					curtext = p;
					autosize = p->to.offset + 4;
					o1 = asmout(p->link, oplook(p->link), aflag);
					curtext = ct;
					autosize = o2;
				} else
					o1 = asmout(p->link, oplook(p->link), aflag);
			}
			return o1;
		}
		break;

	}
	if(aflag)
		return o1;
	v = p->pc;
	switch(o->size) {
	default:
		if(debug['a'])
			Bprint(&bso, " %.8lux:\t\t%P\n", v, p);
		break;
	case 4:
		if(debug['a'])
			Bprint(&bso, " %.8lux: %.8lux\t%P\n", v, o1, p);
		LPUT(o1);
		break;
	case 8:
		if(debug['a'])
			Bprint(&bso, " %.8lux: %.8lux %.8lux%P\n", v, o1, o2, p);
		LPUT(o1);
		LPUT(o2);
		break;
	case 12:
		if(debug['a'])
			Bprint(&bso, " %.8lux: %.8lux %.8lux %.8lux%P\n", v, o1, o2, o3, p);
		LPUT(o1);
		LPUT(o2);
		LPUT(o3);
		break;
	}
	return 0;
}

